-- settings ==============================================================================================================
	local version = "v2.00 (22-01-2011)";
	local soundpath = "Interface\\AddOns\\Killshot\\sounds\\";
	local maxAnnounces = 4;
	local timePerAnnounce = 15;
-- settings ==============================================================================================================


-- init vars =============================================================================================================
	local killingstreak = 0;
	local loaded = 0;
	local announces = 0;
	local lastTime = GetTime();
-- init vars =============================================================================================================


-- load vars =============================================================================================================
	local frame = CreateFrame("FRAME");
	frame:RegisterEvent("ADDON_LOADED");
	
	function frame:OnEvent(event)
		if (event == "ADDON_LOADED") then
			if (loaded == 0) then
				loaded = 1;
				if (saved == 1) then
					kshot:Print("Killshot preferences are loaded. "); 
					if (soundpack == nil) then
						soundpack = "normal";
						kshot:Print("Loaded soundpack = nil, changed it to [normal]");
					end
					if (killingblowMessage == nil) then
						killingblowMessage = "pwned $v! Streak of $s!";
						kshot:Print("Loaded killingblowMessage = nil, changed it to [pwned $v! Streak of $s!]");
					end
					if (sound == nil) then
						sound = true;
						kshot:Print("Loaded sound = nil, changed it to [true]");
					end
					if (scrollingtext == nil) then
						scrollingtext = true;
						kshot:Print("Loaded scrollingtext = nil, changed it to [true]");
					end
					if (emote == nil) then
						emote = true;
						kshot:Print("Loaded emote = nil, changed it to [true]");
					end
					if (solo == nil) then
						solo = false;
						kshot:Print("Loaded solo = nil, changed it to [false]");
					end
					if (maxkillingstreak == nil) then
						maxkillingstreak = 0;
						kshot:Print("Loaded maxkillingstreak = nil, changed it to [0]");
					end
					if (totalkillingblows == nil) then
						totalkillingblows = 0;
						kshot:Print("Loaded totalkillingblows = nil, changed it to [0]");
					end
					if (killingstreaktimes == nil) then
						killingstreaktimes = 0;
						kshot:Print("Loaded killingstreaktimes = nil, changed it to [0]");
					end
					if (sendto == nil) then
						sendto = "RAID";
						kshot:Print("Loaded sendto = nil, changed it to [RAID]");
					end
					if (sendwhat == nil) then
						sendwhat = "streak";
						kshot:Print("Loaded sendwhat = nil, changed it to [streak]");
					end
				else
					kshot:ResetAll();
				end
			end
		end
	end

	frame:SetScript("OnEvent", frame.OnEvent);
	kshot = LibStub("AceAddon-3.0"):NewAddon("kshot", "AceEvent-3.0", "AceConsole-3.0", "LibSink-2.0");
-- load vars =============================================================================================================


-- window ================================================================================================================
	local function makeInfo() 
		local array = { 
			type = "group",
			name = "Killshot",
			args = {
				info_version = {
					type = "description",
					name = version .. "\n\n\nCurrent killing streak: " .. killingstreak .. "\nHighest killing streak: " .. maxkillingstreak .. "\nAverage killing streak: " .. kshot:getStreakAverage() .. "\n\nTotal amount of killingblows: " .. totalkillingblows .. "\nAmount of killingstreaks: " .. killingstreaktimes .. "\n\n",
					order = 10
				},
				info_solo = {
					type = 'toggle',
					name = 'Solo Mode (stops sending/receiving data)',
					get = function() return solo end,
					set = function(info, var) solo = var end,
					width = "full",
					order = 20
				},
				info_streakreset = {
					type = 'execute',
					name = 'Reset Current Streak',
					func = function() kshot:ResetStreak() end,
					width = "full",
					order = 30
				},
				info_streakresetall = {
					type = 'execute',
					name = 'Reset Streak Stats',
					func = function() kshot:ResetStreakInfo() end,
					width = "full",
					order = 40
				},
				info_resetall = {
					type = 'execute',
					name = 'Reset All Settings',
					func = function() kshot:ResetAll() end,
					width = "full",
					order = 50
				}
			}
		}
		return array;
	end

	local function makeSettings() 
		local array = { 
			type = "group",
			name = "Settings",
			args = {
				settings_test = {
					type = 'execute',
					name = 'Killshot Test',
					func = function() kshot:Test() end,
					width = "full",
					order = 10
				},
				settings_soundpack = {
					type = 'select',
					name = 'Select Soundpack',
					desc = 'Select Soundpack',
					get = function() return soundpack end,
					set = function(info, var) soundpack = var end,
					values = {
						normal = "Normal",
						female = "Female",
						sexy = "Sexy",
						custom = "Custom"
					},
					order = 20
				},
				settings_msg = {
					type = 'input',
					name = 'Killingblow Message',
					desc = "$v = victim, $s = streak",
					usage = "<message>",
					get = function() return killingblowMessage end,
					set = function(info, var) killingblowMessage = var end,
					width = "full",
					order = 30
				},
				settings_scrollingtext = {
					type = 'toggle',
					name = 'Scrolling Text Messages',
					get = function() return scrollingtext end,
					set = function(info, var) scrollingtext = var end,
					width = "full",
					order = 40
				},
				settings_emote = {
					type = 'toggle',
					name = 'Emote Messages',
					get = function() return emote end,
					set = function(info, var) emote = var end,
					width = "full",
					order = 50
				},
				settings_sound = {
					type = 'toggle',
					name = 'Sound',
					get = function() return sound end,
					set = function(info, var) sound = var end,
					width = "full",
					order = 60
				}
			}
		}
		return array;
	end
	
	local function makeCompareVersions() 
		local array = { 
			type = "group",
			name = "Compare Versions",
			args = {
				version_sendto = {
					type = 'select',
					name = 'Compare with who?',
					desc = 'Compare with who?',
					get = function() return sendto end,
					set = function(info, var) sendto = var end,
					values = {
						GUILD = "Guild",
						RAID = "Party/Raid",
						BATTLEGROUND = "BG"
					},
					order = 10
				},
				version_check = {
					type = 'execute',
					name = 'Compare your version with others',
					func = function() kshot:CheckVersions(sendto) end,
					width = "full",
					order = 20
				}
			}
		}
		return array;
	end
	
	local function makeStreakAnnouncements() 
		local array = { 
			type = "group",
			name = "Announce Streak Data",
			args = {
				sa_sendto = {
					type = 'select',
					name = 'Send to?',
					desc = 'Send to?',
					get = function() return sendto end,
					set = function(info, var) sendto = var end,
					values = {
						GUILD = "Guild",
						RAID = "Party/Raid",
						BATTLEGROUND = "BG"
					},
					order = 10
				},
				sa_sendwhat = {
					type = 'select',
					name = 'Send what?',
					desc = 'Send what?',
					get = function() return sendwhat end,
					set = function(info, var) sendwhat = var end,
					values = {
						streak = "Current Streak",
						streakmax = "Highest Streak",
						streakavg = "Average Streak"
					},
					order = 20
				},
				sa_send = {
					type = 'execute',
					name = 'Send',
					func = function() kshot:EchoStreakData(sendwhat, sendto) end,
					width = "full",
					order = 30
				}
			}
		}
		return array;
	end
	
	local function makeAbout() 
		local array = { 
			type = "group",
			name = "About",
			args = {
				about_about = {
					type = "description",
					name = "Author: Zwarmapapa \nE-Mail: zwarmapapa@hotmail.com \nWebsite: zwarmapapa.nl \n\nPlaying Horde on Ahn'Qiraj\nFeel free to add me ingame",
					order = 10
				}
			}
		}
		return array;
	end
	

	function kshot:OnInitialize()
		local window = LibStub("AceConfigRegistry-3.0");
		window:RegisterOptionsTable("Killshot", makeInfo);
		window:RegisterOptionsTable("Killshot Settings", makeSettings);
		window:RegisterOptionsTable("Killshot Compare Versions", makeCompareVersions);
		window:RegisterOptionsTable("Killshot Announce Streak Data", makeStreakAnnouncements);
		window:RegisterOptionsTable("Killshot About", makeAbout);
		
		local panel = LibStub("AceConfigDialog-3.0");
		panel:AddToBlizOptions("Killshot", "Killshot");
		panel:AddToBlizOptions("Killshot Settings", "Settings", "Killshot");
		panel:AddToBlizOptions("Killshot Compare Versions", "Compare Versions", "Killshot");
		panel:AddToBlizOptions("Killshot Announce Streak Data", "Announce Streak Data", "Killshot");
		panel:AddToBlizOptions("Killshot About", "About", "Killshot");
		
		
		self:RegisterChatCommand("killshot", function() InterfaceOptionsFrame_OpenToCategory("Killshot") end)
		self:RegisterChatCommand("kshot", function() InterfaceOptionsFrame_OpenToCategory("Killshot") end)
		self:RegisterChatCommand("ks", function() InterfaceOptionsFrame_OpenToCategory("Killshot") end)
	end
-- window ================================================================================================================


-- needed crap ===========================================================================================================
	function kshot:OnEnable()
		self:RegisterEvent("SoundEvent", "SoundEventHandler");
		self:RegisterEvent("PLAYER_DEAD", "PlayerDeathHandler");
		self:RegisterEvent("CHAT_MSG_ADDON", "AddonMessageHandler");
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "CombatLogEventHandler");
		self:RegisterEvent("ZONE_CHANGED_NEW_AREA", "ZoneChangedHandler");
	end
	function kshot:SoundEventHandler(sound)
		if not (PlaySoundFile(sound)) then
			self:ScheduleEvent("SoundEvent", 0.2, sound);
		end
	end
	function kshot:ZoneChangedHandler()
		if (killingstreak > 0) then
			kshot:EchoStreak1();
		end
	end
	function kshot:CombatLogEventHandler(timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags)
		if (not UnitIsPVP("Player")) then return; end;
		if (event == nil) then return; end;
		if (event == "PARTY_KILL") then
			if (sourceFlags == nil) then return; end;
			if (destName == nil) then return; end;
			if (destFlags == nil) then return; end;
			if (bit.band(sourceFlags, COMBATLOG_OBJECT_AFFILIATION_MINE) == COMBATLOG_OBJECT_AFFILIATION_MINE) then
				if (bit.band(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) == COMBATLOG_OBJECT_TYPE_PLAYER) then
				   kshot:kshot_Killshot(UnitName("player"), destName);
				elseif (bit.band(destFlags, COMBATLOG_OBJECT_TYPE_PET) == COMBATLOG_OBJECT_TYPE_PET) then
					if (bit.band(destFlags, COMBATLOG_OBJECT_CONTROL_PLAYER) == COMBATLOG_OBJECT_CONTROL_PLAYER) then
						if (not bit.band(destFlags, COMBATLOG_OBJECT_AFFILIATION_MINE) == COMBATLOG_OBJECT_AFFILIATION_MINE) then
							kshot:kshot_Killshot(UnitName("player"), "an enemy pet, " .. destName);
						end
					end
				end
			end
		end
	end
	function kshot:EchoStreak1()
		kshot:EchoStreak("");
	end
	function kshot:EchoMaxStreak1()
		kshot:EchoMaxStreak("");
	end
	function kshot:EchoAverageStreak1()
		kshot:EchoAverageStreak("");
	end
	function kshot:EchoStreakData(what, channel)
		if (what == "streak") then
			kshot:EchoStreak(channel);
		elseif (what == "streakmax") then
			kshot:EchoMaxStreak(channel);
		elseif (what == "streakavg") then
			kshot:EchoAverageStreak(channel);
		end
	end
	function kshot:PlayerDeathHandler()
		if (UnitIsPVP("player")) then
			killingstreak = 0;
		end
	end
	function kshot:ScrollText(msg, force)
		if( (scrollingtext == true) or (force == true) )then
			if (IsAddOnLoaded("Blizzard_CombatText")) then 
				CombatText_AddMessage(msg, CombatText_StandardSCroll, 1, 0.1, 0.1, "crit", 0);        
			elseif (IsAddOnLoaded("SCT")) then 
				SCT:DisplayText(msg, {r=1.0, g=0.1, b=0.1}, 1, "event", 1, 1);
			end
			kshot:Print(msg);
		end
	end
	function kshot:kshot_SendVersionResponse(requester, targetGroup)
		SendAddonMessage("kshot_VersionCheckResponse", requester .. ":" .. UnitName("player") .. " is on version " .. version , targetGroup);
	end
	function kshot:CheckVersions(with)
		if (with == "GUILD") then
			kshot:CheckGuildVersions();
		elseif (with == "RAID") then
			kshot:CheckRaidVersions();
		elseif (with == "BATTLEGROUND") then
			kshot:CheckBGVersions();
		end
	end
	function kshot:CheckGuildVersions()
		SendAddonMessage("kshot_GuildVersionCheckRequest", UnitName("player"), "GUILD");
		kshot:Print(UnitName("player") .. " is on version " .. version);
	end
	function kshot:CheckRaidVersions()
		SendAddonMessage("kshot_RaidVersionCheckRequest", UnitName("player"), "RAID");
		kshot:Print(UnitName("player") .. " is on version " .. version);
	end
	function kshot:CheckBGVersions()
		SendAddonMessage("kshot_BGVersionCheckRequest", UnitName("player"), "BATTLEGROUND");
		kshot:Print(UnitName("player") .. " is on version " .. version);
	end
	function kshot:kshot_SoundPack(soundfilelink)
		if(sound == true) then
			local soundfile = soundpath .. soundfilelink;
			kshot:SoundEventHandler(soundfile);
		end
	end
	function kshot:GetMessageGroup()
		local targetGroup = "RAID";
		if (kshot:IsInBattleground() == true) then
			targetGroup = "BATTLEGROUND";
		end
		return targetGroup;
	end
	function kshot:IsInBattleground()
		local inBG = false;
		local zone = GetZoneText();
		if ((zone == "Warsong Gulch") or (zone == "Eye of the Storm") or (zone == "Arathi Basin") or (zone == "Alterac Valley") or (zone == "Halaa") or (zone == "Wintergrasp") or (zone == "Strand of the Ancients") or (zone == "Isle of Conquest") or (zone == "Dalaran Arena") or (zone ==  "Nagrand Arena") or (zone == "Blade's Edge Arena") or (zone == "The Ring of Valor") or (zone == "Ruins of Lordaeron")) then
			inBG = true;
		end
		return inBG;
	end
	function kshot:UpdateAnnounces()
		local newTime = GetTime();
		local Time = newTime - lastTime;
		while (Time > timePerAnnounce) do
			lastTime = lastTime + timePerAnnounce;
			Time = newTime - lastTime;
			if (announces > 0) then
				announces = announces - 1;
			end
		end
	end
	function kshot:getStreakAverage()
		local avgCalc = totalkillingblows/killingstreaktimes;
		if (totalkillingblows == 0) then
			avgCalc = 0;
		end
		return avgCalc;
	end
	function kshot:getStreakMessage(victim, streak)
		local theKillingblowMessage = killingblowMessage;
		theKillingblowMessage = string.gsub(theKillingblowMessage, "$v", victim);
		theKillingblowMessage = string.gsub(theKillingblowMessage, "$s", streak);
		return theKillingblowMessage;
	end
-- needed crap ===========================================================================================================


-- streak announcements ==================================================================================================
	function kshot:EchoStreak(channel)
		local msg = " current streak is: " .. killingstreak;
		
		if (channel == "") then
			kshot:ScrollText("Your" .. msg, true);
		else
			if (solo == false) then
				kshot:UpdateAnnounces();
				if (announces < maxAnnounces) then
					SendAddonMessage("kshot_StreakAnnounceEvent", UnitName("player") .. msg, channel);
					kshot:Print("Your current streak has been sended to your " .. channel);
					announces = announces + 1;
				else
					kshot:Print("Killsot's Anti-Spam stopped your streak-data announcement!");
				end
			end
		end
	end
	
	function kshot:EchoMaxStreak(channel)
		local msg = " highest streak is: " .. maxkillingstreak;
		
		if (channel == "") then
			kshot:ScrollText("Your" .. msg, true);
		else
			if (solo == false) then
				kshot:UpdateAnnounces();
				if (announces < maxAnnounces) then
					SendAddonMessage("kshot_StreakAnnounceEvent", UnitName("player") .. msg, channel);
					kshot:Print("Your highest streak has been sended to your " .. channel);
					announces = announces + 1;
				else
					kshot:Print("Killsot's Anti-Spam stopped your streak-data announcement!");
				end
			end
		end
	end
	
	function kshot:EchoAverageStreak(channel)
		local avg = kshot:getStreakAverage();
		
		local msg1 = " average streak is: " .. avg;
		local msg2 = "Total amount of killingblows: " .. totalkillingblows;
		local msg3 = "Amount of killingstreaks: " .. killingstreaktimes;
		
		if (channel == "") then
			kshot:ScrollText("Your" .. msg1, true);
			kshot:Print(msg2);
			kshot:Print(msg3);
		else
			if (solo == false) then
				kshot:UpdateAnnounces();
				if (announces < maxAnnounces) then
					SendAddonMessage("kshot_StreakAnnounceEvent", UnitName("player") .. msg1, channel);
					SendAddonMessage("kshot_StreakAnnounceEvent", msg2, channel);
					SendAddonMessage("kshot_StreakAnnounceEvent", msg3, channel);
					kshot:Print("Your average streak has been sended to your " .. channel);
					announces = announces + 1;
				else
					kshot:Print("Killsot's Anti-Spam stopped your streak-data announcement!");
				end
			end
		end
	end
-- streak announcements ==================================================================================================


-- main script ===========================================================================================================
	function kshot:GetKillshotSound(kills)
		local soundpackNr = "1";
		if (soundpack == "normal") then
			soundpackNr = "1";
		elseif (soundpack == "female") then
			soundpackNr = "2";
		elseif (soundpack == "sexy") then
			soundpackNr = "3";
		elseif (soundpack == "custom") then
			soundpackNr = "4";
		else
			soundpack = "normal";
			soundpackNr = "1";
		end
		
		
		local soundfile = "";
				if (kills > 19) then soundfile = "sp".. soundpackNr .."-14.mp3";
			elseif (kills > 15) then soundfile = "sp".. soundpackNr .."-13.mp3";
			elseif (kills > 12) then soundfile = "sp".. soundpackNr .."-12.mp3";
			elseif (kills > 10) then soundfile = "sp".. soundpackNr .."-11.mp3";
			elseif (kills >  9) then soundfile = "sp".. soundpackNr .."-10.mp3";
			elseif (kills >  8) then soundfile = "sp".. soundpackNr .. "-9.mp3";
			elseif (kills >  7) then soundfile = "sp".. soundpackNr .. "-8.mp3";
			elseif (kills >  6) then soundfile = "sp".. soundpackNr .. "-7.mp3";
			elseif (kills >  5) then soundfile = "sp".. soundpackNr .. "-6.mp3";
			elseif (kills >  4) then soundfile = "sp".. soundpackNr .. "-5.mp3";
			elseif (kills >  3) then soundfile = "sp".. soundpackNr .. "-4.mp3";
			elseif (kills >  2) then soundfile = "sp".. soundpackNr .. "-3.mp3";
			elseif (kills >  1) then soundfile = "sp".. soundpackNr .. "-2.mp3";
			else soundfile = "sp".. soundpackNr .. "-1.mp3"; end;
		return soundfile;
	end
	
	function kshot:AddonMessageHandler(prefix, text, type, target)
		if not (target == UnitName("player")) then
			if (prefix == "kshot_txt") then
				kshot:Print(text);
			
			elseif (prefix == "kshot_StreakAnnounceEvent") then
				if(solo == false) then
					kshot:Print(text);
				end
			
			elseif (prefix == "kshot_ScrollingTextEvent") then
				if(solo == false) then
					kshot:ScrollText(text, false);
				end
			elseif (prefix == "kshot_KillSoundEvent") then
				if(solo == false) then
					kshot:kshot_SoundPack(kshot:GetKillshotSound(tonumber(text)));
				end
			
			elseif (prefix == "kshot_BGVersionCheckRequest") then
				kshot:kshot_SendVersionResponse(text, "BATTLEGROUND");
			elseif (prefix == "kshot_RaidVersionCheckRequest") then
				kshot:kshot_SendVersionResponse(text, "RAID");
			elseif (prefix == "kshot_GuildVersionCheckRequest") then
				kshot:kshot_SendVersionResponse(text, "GUILD");
			
			elseif (prefix == "kshot_VersionCheckResponse") then
				local nameLength = string.len(UnitName("player"));
				if (UnitName("player") == string.sub(text, 0, nameLength)) then
					local startIndex = nameLength + 2;
					kshot:Print(string.sub(text, startIndex));
				else
					kshot:Print("Didn't Match: " .. text);
				end
			end
			
		end
	end

	function kshot:kshot_Killshot(killer, victim)
		killingstreak = killingstreak + 1;
		totalkillingblows = totalkillingblows + 1;
		
		if (killingstreak == 1) then
			killingstreaktimes = killingstreaktimes + 1;
		end
		
		if (emote == true) then
			SendChatMessage(kshot:getStreakMessage(victim, killingstreak), "EMOTE");
		end
		
		kshot:ScrollText("You " .. kshot:getStreakMessage(victim, killingstreak), false);
		
		if (killingstreak > maxkillingstreak) then
			maxkillingstreak = killingstreak;
			kshot:ScrollText("You have set a new record!", true);
		end
		
		if (solo == false) then
			SendAddonMessage("kshot_ScrollingTextEvent", killer .. " " .. kshot:getStreakMessage(victim, killingstreak), kshot:GetMessageGroup());
			SendAddonMessage("kshot_KillSoundEvent", killingstreak, kshot:GetMessageGroup());
		end
		
		kshot:kshot_SoundPack(kshot:GetKillshotSound(killingstreak));
	end
-- main script ===========================================================================================================


-- used functions ========================================================================================================	
	function kshot:Test()
		local killingstreaktest = killingstreak + 1;
		if (emote == true) then
			SendChatMessage(kshot:getStreakMessage("TEST", killingstreaktest), "EMOTE");
		end
		kshot:ScrollText("You " .. kshot:getStreakMessage("TEST", killingstreaktest), false);
		kshot:kshot_SoundPack(kshot:GetKillshotSound(killingstreaktest));
	end
	
	function kshot:ResetStreak()
		killingstreak = 0;
		kshot:Print("Your Killshot streak has been resetted");
	end
	
	function kshot:ResetStreakInfo()
		killingstreak = 0;
		maxkillingstreak = 0;
		totalkillingblows = 0;
		killingstreaktimes = 0;
		kshot:Print("Your streak data has been deleted");
	end
	
	function kshot:ResetAll()
		saved = 1;
		soundpack = "normal";
		killingblowMessage = "pwned $v! Streak of $s!";
		sound = true;
		scrollingtext = true;
		emote = true;
		solo = false;
		killingstreak = 0;
		maxkillingstreak = 0;
		totalkillingblows = 0;
		killingstreaktimes = 0;
		kshot:Print("Killshot detected a new user"); 
	end
-- used functions ========================================================================================================